CloseableHttpClient (Apache HttpClient 4.5.13 API)
Date: 2020-10-03

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.impl.client
Class CloseableHttpClient

    java.lang.Object
      org.apache.http.impl.client.CloseableHttpClient

All Implemented Interfaces:
  Closeable, HttpClient

Direct Known Subclasses:
  AbstractHttpClient

    @Contract(threading=SAFE)
    public abstract class CloseableHttpClient

extends Object
implements HttpClient, Closeable

Base implementation of `HttpClient` that also implements `Closeable`.

Since:
  4.3

Constructor Summary
`CloseableHttpClient()`

Method Summary
`protected abstract CloseableHttpResponse` | `doExecute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, org.apache.http.protocol.HttpContext context)`
`CloseableHttpResponse` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request)` Executes HTTP request using the default context.
`CloseableHttpResponse` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, org.apache.http.protocol.HttpContext context)` Executes HTTP request using the given context.
`
`<T> T`
` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, ResponseHandler<? extends T> responseHandler)` Executes a request using the default context and processes the response using the given response handler.
`
`<T> T`
` | `execute(org.apache.http.HttpHost target, org.apache.http.HttpRequest request, ResponseHandler<? extends T> responseHandler, org.apache.http.protocol.HttpContext context)` Executes a request using the default context and processes the response using the given response handler.
`CloseableHttpResponse` | `execute(HttpUriRequest request)` Executes HTTP request using the default context.
`CloseableHttpResponse` | `execute(HttpUriRequest request, org.apache.http.protocol.HttpContext context)` Executes HTTP request using the given context.
`
`<T> T`
` | `execute(HttpUriRequest request, ResponseHandler<? extends T> responseHandler)` Executes a request using the default context and processes the response using the given response handler.
`
`<T> T`
` | `execute(HttpUriRequest request, ResponseHandler<? extends T> responseHandler, org.apache.http.protocol.HttpContext context)` Executes a request using the default context and processes the response using the given response handler.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.apache.http.client.HttpClient
`getConnectionManager, getParams`

Methods inherited from interface java.io.Closeable
`close`

Constructor Detail

### CloseableHttpClient

    public CloseableHttpClient()

Method Detail

### doExecute

    protected abstract CloseableHttpResponse doExecute(org.apache.http.HttpHost target,
                                                       org.apache.http.HttpRequest request,
                                                       org.apache.http.protocol.HttpContext context)
                                                throws IOException,
                                                       ClientProtocolException

  Throws:
    `IOException`
    `ClientProtocolException`

### execute

    public CloseableHttpResponse execute(org.apache.http.HttpHost target,
                                         org.apache.http.HttpRequest request,
                                         org.apache.http.protocol.HttpContext context)
                                  throws IOException,
                                         ClientProtocolException

  Executes HTTP request using the given context.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
    `context` - the context to use for the execution, or `null` to use the default context
  Returns:
    the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public CloseableHttpResponse execute(HttpUriRequest request,
                                         org.apache.http.protocol.HttpContext context)
                                  throws IOException,
                                         ClientProtocolException

  Executes HTTP request using the given context.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `request` - the request to execute
    `context` - the context to use for the execution, or `null` to use the default context
  Returns:
    the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public CloseableHttpResponse execute(HttpUriRequest request)
                                  throws IOException,
                                         ClientProtocolException

  Executes HTTP request using the default context.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `request` - the request to execute
  Returns:
    the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public CloseableHttpResponse execute(org.apache.http.HttpHost target,
                                         org.apache.http.HttpRequest request)
                                  throws IOException,
                                         ClientProtocolException

  Executes HTTP request using the default context.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
  Returns:
    the response to the request. This is always a final response, never an intermediate response with an 1xx status code. Whether redirects or authentication challenges will be returned or handled automatically depends on the implementation and configuration of this client.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public <T> T execute(HttpUriRequest request,
                         ResponseHandler<? extends T> responseHandler)
              throws IOException,
                     ClientProtocolException

  Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `request` - the request to execute
    `responseHandler` - the response handler
  Returns:
    the response object as generated by the response handler.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public <T> T execute(HttpUriRequest request,
                         ResponseHandler<? extends T> responseHandler,
                         org.apache.http.protocol.HttpContext context)
              throws IOException,
                     ClientProtocolException

  Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `request` - the request to execute
    `responseHandler` - the response handler
    `context` - the context to use for the execution, or `null` to use the default context
  Returns:
    the response object as generated by the response handler.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public <T> T execute(org.apache.http.HttpHost target,
                         org.apache.http.HttpRequest request,
                         ResponseHandler<? extends T> responseHandler)
              throws IOException,
                     ClientProtocolException

  Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
    `responseHandler` - the response handler
  Returns:
    the response object as generated by the response handler.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

### execute

    public <T> T execute(org.apache.http.HttpHost target,
                         org.apache.http.HttpRequest request,
                         ResponseHandler<? extends T> responseHandler,
                         org.apache.http.protocol.HttpContext context)
              throws IOException,
                     ClientProtocolException

  Executes a request using the default context and processes the response using the given response handler. The content entity associated with the response is fully consumed and the underlying connection is released back to the connection manager automatically in all cases relieving individual `ResponseHandler`s from having to manage resource deallocation internally.

  Specified by:
    `execute` in interface `HttpClient`
  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
    `responseHandler` - the response handler
    `context` - the context to use for the execution, or `null` to use the default context
  Returns:
    the response object as generated by the response handler.
  Throws:
    `IOException` - in case of a problem or the connection was aborted
    `ClientProtocolException` - in case of an http protocol error

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999–2020 The Apache Software Foundation. All rights reserved.